 /**
  * ToGenericBaseConverter3
  *
  * @version 2-Nov-2007
  * @author Adriano Luchetta
  *
  * converte numeri interi da base decimale a un'altra base 2 <= b <= 36 e invia
  * la codifica a standard output.
  * Se la base e' superiore a 10 usa come cifre i caratteri 'A', 'B', ..., 'Z'.
  * I numeri interi e la base sono acquisiti da standard input.
  * Il programma termina quando viene inserita la riga vuota.
  *
  */

import java.util.Scanner;

public class ToGenericBaseConverter3
{
   public static void main(String[] args)
   {
      final String END_OF_DATA = "";
      final char[] DIGITS = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
                             'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J',
                             'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T',
                             'U', 'V', 'W', 'X', 'Y', 'Z' };
      final int MIN_BASE = 2;
      final int MAX_BASE = DIGITS.length;

      // prompt all'operatore
      System.out.println("*** CONVERTITORE DA BASE DECIMALE A BASE GENERICA ***\n");

      //Lettura da standard input
      Scanner in = new Scanner(System.in);

      while (true)
      {
         System.out.print("inserire numero e base: ");

         String line = in.nextLine();

         if (line.equals(END_OF_DATA))
            break;

         Scanner tok = new Scanner(line);

         int n = 0;
         if (tok.hasNextInt())
            n = tok.nextInt();

         int base = 0;
         if (tok.hasNextInt())
            base = tok.nextInt();

         tok.close();
         
         System.out.println("numero da convertire: " + n + ", base: " + base);

         if (base < MIN_BASE || base > MAX_BASE)
            System.out.println("base " + base + " non ammessa\n");
         else
         {
            System.out.print("cifre usate in base " + base + ": ");
            for (int i = 0; i < base; i++)
               System.out.print(DIGITS[i]);

            System.out.println("");

            int p = n;
            String sign = "";
            if (n < 0)
            {
               sign = "-";
               p = -n;
            }

            String nStr = "";
            while (p > 0)
            {
               int q = p % base;
               nStr = DIGITS[q] + nStr;

               p = p / base;
            }

            System.out.println(n + " decimale = " + sign + nStr + " in base " + base + "\n");
         }
      }
      
      System.out.println("\n ***FINE ***");
      in.close();
   }
}
